package net.vidageek.mirror;

import java.lang.reflect.AccessibleObject;

import net.vidageek.mirror.reflect.AllMemberHandler;
import net.vidageek.mirror.reflect.MemberHandler;

public class MemberController {

	private final AccessibleObject member;

	public MemberController(final AccessibleObject member) {
		if (member == null) {
			throw new IllegalArgumentException("Argument member cannot be null");
		}
		this.member = member;
	}

	public AllMemberHandler reflectAll() {
		return new AllMemberHandler(member);
	}

	public MemberHandler reflect() {
		return new MemberHandler(member);
	}

}
