/**
 * 
 */
package net.vidageek.mirror.reflect;

import static net.vidageek.mirror.Mirror.on;

import java.lang.reflect.Field;

/**
 * @author jonasabreu
 * 
 */
public class FieldReflector {

	private final String fieldName;

	public FieldReflector(final String fieldName) {
		if (fieldName == null || fieldName.trim().length() == 0) {
			throw new IllegalArgumentException(
					"fieldName cannot be null or blank");
		}
		this.fieldName = fieldName;
	}

	@SuppressWarnings("unchecked")
	public Field onClass(final Class clazz) {
		if (clazz == null) {
			throw new IllegalArgumentException("argument clazz cannot be null.");
		}

		for (final Object f : on(clazz).reflectAll().fields()) {
			final Field field = (Field) f;
			if (fieldName.equals(field.getName())) {
				field.setAccessible(true);
				return field;
			}
		}

		return null;
	}
}
